Attribute VB_Name = "1"
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal Y As Long) As Long
Private Declare Function SetPixelV Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Public Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long

Private Type RGBTHREE
    rgbtBlue As Integer
    rgbtGreen As Integer
    rgbtRed As Integer
End Type

Private Function AlphaBlendRGB(ByVal Color1 As Long, ByVal Color2 As Long, ByVal Opacity1 As Integer) As Long
    Dim src1 As RGBTHREE
    Dim src2 As RGBTHREE
    Dim nRed As Long
    Dim nGreen As Long
    Dim nBlue As Long
    GetRGB Color1, src1
    GetRGB Color2, src2
    nRed = (src1.rgbtRed * Opacity1 + src2.rgbtRed * (100 - Opacity1)) \ 100
    nGreen = (src1.rgbtGreen * Opacity1 + src2.rgbtGreen * (100 - Opacity1)) \ 100
    nBlue = (src1.rgbtBlue * Opacity1 + src2.rgbtBlue * (100 - Opacity1)) \ 100
    AlphaBlendRGB = RGB(nRed, nGreen, nBlue)
End Function

Private Function GetRGB(ByVal ColorVal As Long, Result As RGBTHREE) As Boolean
    Result.rgbtRed = ColorVal And 255
    Result.rgbtGreen = (ColorVal And 65535) \ 256
    Result.rgbtBlue = ColorVal \ 65536
End Function

Private Function GetAlpha(ByVal ColorVal As Long, x As Long, Y As Long, Mask As PictureBox)
    NewGetAlpha = ColorVal And 255
    NewColor = GetPixel(Mask.hdc, x, Y)
    GetAlpha = Int(NewGetAlpha / 255 * 100)
    GetAlpha = 100 - GetAlpha
End Function

Public Sub PaintAlphaPic(Mask As PictureBox, BitMap As PictureBox, ResultPicture As PictureBox)
    Dim nX As Long
    Dim nY As Long
    Dim nSrc1Color As Long
    Dim nSrc2Color As Long
    Dim nResultColor As Long
    
    Mask.ScaleMode = 3
    Mask.AutoSize = True
    Mask.AutoRedraw = True
    Mask.Visible = False
    
    BitMap.ScaleMode = 3
    BitMap.AutoSize = True
    BitMap.AutoRedraw = True
    BitMap.Visible = False
    
    ResultPicture.AutoRedraw = True
    ResultPicture.ScaleMode = 3
    ResultPicture.Visible = False
    
    If Mask.ScaleHeight = BitMap.ScaleHeight And Mask.ScaleWidth = BitMap.ScaleWidth Then
    ResultPicture.Height = BitMap.Height
    ResultPicture.Width = BitMap.Width

    For nY = 0 To BitMap.ScaleHeight - 1
        For nX = 0 To BitMap.ScaleWidth - 1
            nSrc1Color = GetPixel(ResultPicture.hdc, nX, nY)
            nSrc2Color = GetPixel(BitMap.hdc, nX, nY)
            AlphaColor = GetPixel(Mask.hdc, nX, nY)
            AlphaValue = GetAlpha(AlphaColor, nX, nY, Mask)
            nResultColor = AlphaBlendRGB(nSrc1Color, nSrc2Color, AlphaValue)
            SetPixelV ResultPicture.hdc, nX, nY, nResultColor
        Next nX
    Next nY
    End If
    ResultPicture.Visible = True
End Sub

Public Sub PaintAlphaPicToDesctop(Mask As PictureBox, BitMap As PictureBox)
    Dim nX As Long
    Dim nY As Long
    Dim nSrc1Color As Long
    Dim nSrc2Color As Long
    Dim nResultColor As Long
    
    Mask.ScaleMode = 3
    Mask.AutoSize = True
    Mask.AutoRedraw = True
    Mask.Visible = False
    
    BitMap.ScaleMode = 3
    BitMap.AutoSize = True
    BitMap.AutoRedraw = True
    BitMap.Visible = False
    
    If Mask.ScaleHeight = BitMap.ScaleHeight And Mask.ScaleWidth = BitMap.ScaleWidth Then
    DesktopDC = GetDC(0)
    For nY = 0 To BitMap.ScaleHeight - 1
        For nX = 0 To BitMap.ScaleWidth - 1
            nSrc1Color = GetPixel(DesktopDC, nX, nY)
            nSrc2Color = GetPixel(BitMap.hdc, nX, nY)
            AlphaColor = GetPixel(Mask.hdc, nX, nY)
            AlphaValue = GetAlpha(AlphaColor, nX, nY, Mask)
            nResultColor = AlphaBlendRGB(nSrc1Color, nSrc2Color, AlphaValue)
            SetPixelV DesktopDC, nX, nY, nResultColor
        Next nX
    Next nY
    End If
End Sub
